GDAL

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
OGRMultiPolygon Class Reference

A collection of non-overlapping OGRPolygon. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRMultiPolygon:

## Public Types
typedef OGRPolygon | ChildType
| Type of child elements.

## Public Member Functions
| OGRMultiPolygon ()=default
| Create an empty multi polygon collection.
| OGRMultiPolygon (const OGRMultiPolygon &other)
| Copy constructor.
| OGRMultiPolygon (OGRMultiPolygon &&other)=default
| Move constructor.
OGRMultiPolygon & | operator= (const OGRMultiPolygon &other)
| Assignment operator.
OGRMultiPolygon & | operator= (OGRMultiPolygon &&other)=default
| Move assignment operator.
ChildType ** | begin ()
| Return begin of iterator.
ChildType ** | end ()
| Return end of iterator.
const ChildType *const * | begin () const
| Return begin of iterator.
const ChildType *const * | end () const
| Return end of iterator.
OGRPolygon * | getGeometryRef (int i)
| See OGRGeometryCollection::getGeometryRef()
const OGRPolygon * | getGeometryRef (int i) const
| See OGRGeometryCollection::getGeometryRef()
const char * | getGeometryName () const override
| Fetch WKT name for geometry type.
OGRwkbGeometryType | getGeometryType () const override
| Fetch geometry type.
OGRMultiPolygon * | clone () const override
| Make a copy of this object.
virtual OGRErr | importFromWkb (const unsigned char *, size_t, OGRwkbVariant, size_t &nBytesConsumedOut) override
| Assign geometry from well known binary data.
virtual std::string | exportToWkt (const OGRWktOptions &opts=OGRWktOptions(), OGRErr *err=nullptr) const override
| Export a multipolygon to WKT.
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const override
| Returns if this geometry is or has curve geometry.
OGRGeometryCollection * | toUpperClass ()
| Return pointer of this in upper class.
const OGRGeometryCollection * | toUpperClass () const
| Return pointer of this in upper class.
void | accept (IOGRGeometryVisitor *visitor) override
| Accept a visitor.
void | accept (IOGRConstGeometryVisitor *visitor) const override
| Accept a visitor.
OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known text format.
virtual std::string | exportToWkt (const OGRWktOptions &opts=OGRWktOptions(), OGRErr *err=nullptr) const=0
| Export a WKT geometry.
OGRErr | importFromWkt (const char **) override
| deprecated
virtual OGRErr | importFromWkt (const char **ppszInput)=0
| Assign geometry from well known text data.
OGRErr | importFromWkt (char **ppszInput)
| Deprecated.
virtual OGRErr | PointOnSurface (OGRPoint *poPoint) const
| This method relates to the SFCOM IMultiSurface::get_PointOnSurface() method.
int | getDimension () const override
| Get the dimension of this object.
void | empty () override
| Clear geometry information.
OGRErr | transform (OGRCoordinateTransformation *poCT) override
| Apply arbitrary coordinate transformation to geometry.
void | flattenTo2D () override
| Convert geometry to strictly 2D.
OGRBoolean | IsEmpty () const override
| Returns TRUE (non-zero) if the object has no points.
bool | segmentize (double dfMaxLength) override
| Modify the geometry such it has no segment longer then the given distance.
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=nullptr) const override
| Return curve version of this geometry.
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=nullptr) const override
| Return, possibly approximate, non-curve version of this geometry.
virtual double | get_GeodesicArea (const OGRSpatialReference *poSRSOverride=nullptr) const
| Compute area of geometry collection, considered as a surface on the underlying ellipsoid of the SRS attached to the geometry.
virtual double | get_GeodesicLength (const OGRSpatialReference *poSRSOverride=nullptr) const
| Get the length of the collection,where curve edges are geodesic lines on the underlying ellipsoid of the SRS attached to the geometry.
size_t | WkbSize () const override
| Returns size of related binary representation.
OGRErr | importFromWkb (const GByte *, size_t=static_cast< size_t >(-1), OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data.
OGRErr | exportToWkb (unsigned char *, const OGRwkbExportOptions *=nullptr) const override
| Convert a geometry into well known binary format.
OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known binary format.
virtual double | get_Length () const
| Compute the length of a multicurve.
virtual double | get_Area () const
| Compute area of geometry collection.
void | getEnvelope (OGREnvelope *psEnvelope) const override
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.
void | getEnvelope (OGREnvelope3D *psEnvelope) const override
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.
int | getNumGeometries () const
| Fetch number of geometries in container.
OGRBoolean | Equals (const OGRGeometry *) const override
| Returns TRUE if two geometries are equivalent.
bool | setCoordinateDimension (int nDimension) override
| Set the coordinate dimension.
bool | set3D (OGRBoolean bIs3D) override
| Add or remove the Z coordinate dimension.
bool | setMeasured (OGRBoolean bIsMeasured) override
| Add or remove the M coordinate dimension.
virtual OGRErr | addGeometry (const OGRGeometry *)
| Add a geometry to the container.
OGRErr | addGeometry (std::unique_ptr< OGRGeometry > geom)
| Add a geometry directly to the container.
virtual OGRErr | addGeometryDirectly (OGRGeometry *)
| Add a geometry directly to the container.
virtual OGRErr | removeGeometry (int iIndex, int bDelete=TRUE)
| Remove a geometry from the container.
std::unique_ptr< OGRGeometry > | stealGeometry (int iIndex)
| Remove a geometry from the container and return it to the caller.
bool | hasEmptyParts () const override
| Returns whether a geometry has empty parts/rings.
void | removeEmptyParts () override
| Remove empty parts/rings from this geometry.
virtual void | assignSpatialReference (const OGRSpatialReference *poSR) override
| Assign spatial reference to this object.
void | closeRings () override
| Force rings to be closed.
void | swapXY () override
| Swap x and y coordinates.
bool | operator== (const OGRGeometry &other) const
| Returns if two geometries are equal.
bool | operator!= (const OGRGeometry &other) const
| Returns if two geometries are different.
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object.
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object.
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid.
virtual OGRGeometry * | MakeValid (CSLConstList papszOptions=nullptr) const
| Attempts to make an invalid geometry valid without losing vertices.
virtual OGRGeometry * | Normalize () const
| Attempts to bring geometry into normalized/canonical form.
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple.
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring.
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3.
void | dumpReadable (FILE *, const char *=nullptr, CSLConstList papszOptions=nullptr) const
| Dump geometry in well known text format to indicated output file.
std::string | dumpReadable (const char *=nullptr, CSLConstList papszOptions=nullptr) const
| Dump geometry in well known text format to indicated output file.
virtual char * | exportToGML (const char *const *papszOptions=nullptr) const
| Convert a geometry into GML format.
virtual char * | exportToKML () const
| Convert a geometry into KML format.
virtual char * | exportToJson (CSLConstList papszOptions=nullptr) const
| Convert a geometry into GeoJSON format.
GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt, bool bRemoveEmptyParts=false) const
| Returns a GEOSGeom object corresponding to the geometry.
void | roundCoordinates (const OGRGeomCoordinatePrecision &sPrecision)
| Round coordinates of the geometry to the specified precision.
void | roundCoordinatesIEEE754 (const OGRGeomCoordinateBinaryPrecision &options)
| Round coordinates of a geometry, exploiting characteristics of the IEEE-754 double-precision binary representation.
const OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object.
OGRErr | transformTo (const OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system.
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect?
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness.
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching.
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing.
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment.
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment.
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap.
virtual OGRGeometry * | Boundary () const
| Compute boundary.
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries.
virtual OGRGeometry * | ConvexHull () const
| Compute convex hull.
virtual OGRGeometry * | ConcaveHull (double dfRatio, bool bAllowHoles) const
| Compute "concave hull" of a geometry.
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const
| Compute buffer of geometry.
virtual OGRGeometry * | BufferEx (double dfDist, CSLConstList papszOptions) const
| Compute buffer of geometry.
virtual OGRGeometry * | Intersection (const OGRGeometry *) const
| Compute intersection.
virtual OGRGeometry * | Union (const OGRGeometry *) const
| Compute union.
virtual OGRGeometry * | UnionCascaded () const
| Compute union using cascading.
OGRGeometry * | UnaryUnion () const
| Returns the union of all components of a single geometry.
virtual OGRGeometry * | Difference (const OGRGeometry *) const
| Compute difference.
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const
| Compute symmetric difference.
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid.
virtual OGRGeometry * | Simplify (double dTolerance) const
| Simplify the geometry.
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const
| Simplify the geometry while preserving topology.
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const
| Return a Delaunay triangulation of the vertices of the geometry.
virtual OGRGeometry * | ConstrainedDelaunayTriangulation () const
| Return a constrained Delaunay triangulation of the vertices of the given polygon(s).
virtual OGRGeometry * | Polygonize () const
| Polygonizes a set of sparse edges.
virtual OGRGeometry * | BuildArea () const
| Polygonize a linework assuming inner polygons are holes.
virtual double | Distance3D (const OGRGeometry *poOtherGeom) const
| Returns the 3D distance between two geometries.
OGRGeometry * | SetPrecision (double dfGridSize, int nFlags) const
| Set the geometry's precision, rounding all its coordinates to the precision grid, and making sure the geometry is still valid.
bool | IsRectangle () const
| Returns whether the geometry is a polygon with 4 corners forming a rectangle.
OGRPoint * | toPoint ()
| Down-cast to OGRPoint*.
const OGRPoint * | toPoint () const
| Down-cast to OGRPoint*.
OGRCurve * | toCurve ()
| Down-cast to OGRCurve*.
const OGRCurve * | toCurve () const
| Down-cast to OGRCurve*.
OGRSimpleCurve * | toSimpleCurve ()
| Down-cast to OGRSimpleCurve*.
const OGRSimpleCurve * | toSimpleCurve () const
| Down-cast to OGRSimpleCurve*.
OGRLineString * | toLineString ()
| Down-cast to OGRLineString*.
const OGRLineString * | toLineString () const
| Down-cast to OGRLineString*.
OGRLinearRing * | toLinearRing ()
| Down-cast to OGRLinearRing*.
const OGRLinearRing * | toLinearRing () const
| Down-cast to OGRLinearRing*.
OGRCircularString * | toCircularString ()
| Down-cast to OGRCircularString*.
const OGRCircularString * | toCircularString () const
| Down-cast to OGRCircularString*.
OGRCompoundCurve * | toCompoundCurve ()
| Down-cast to OGRCompoundCurve*.
const OGRCompoundCurve * | toCompoundCurve () const
| Down-cast to OGRCompoundCurve*.
OGRSurface * | toSurface ()
| Down-cast to OGRSurface*.
const OGRSurface * | toSurface () const
| Down-cast to OGRSurface*.
OGRPolygon * | toPolygon ()
| Down-cast to OGRPolygon*.
const OGRPolygon * | toPolygon () const
| Down-cast to OGRPolygon*.
OGRTriangle * | toTriangle ()
| Down-cast to OGRTriangle*.
const OGRTriangle * | toTriangle () const
| Down-cast to OGRTriangle*.
OGRCurvePolygon * | toCurvePolygon ()
| Down-cast to OGRCurvePolygon*.
const OGRCurvePolygon * | toCurvePolygon () const
| Down-cast to OGRCurvePolygon*.
OGRGeometryCollection * | toGeometryCollection ()
| Down-cast to OGRGeometryCollection*.
const OGRGeometryCollection * | toGeometryCollection () const
| Down-cast to OGRGeometryCollection*.
OGRMultiPoint * | toMultiPoint ()
| Down-cast to OGRMultiPoint*.
const OGRMultiPoint * | toMultiPoint () const
| Down-cast to OGRMultiPoint*.
OGRMultiLineString * | toMultiLineString ()
| Down-cast to OGRMultiLineString*.
const OGRMultiLineString * | toMultiLineString () const
| Down-cast to OGRMultiLineString*.
OGRMultiPolygon * | toMultiPolygon ()
| Down-cast to OGRMultiPolygon*.
const OGRMultiPolygon * | toMultiPolygon () const
| Down-cast to OGRMultiPolygon*.
OGRMultiCurve * | toMultiCurve ()
| Down-cast to OGRMultiCurve*.
const OGRMultiCurve * | toMultiCurve () const
| Down-cast to OGRMultiCurve*.
OGRMultiSurface * | toMultiSurface ()
| Down-cast to OGRMultiSurface*.
const OGRMultiSurface * | toMultiSurface () const
| Down-cast to OGRMultiSurface*.
OGRPolyhedralSurface * | toPolyhedralSurface ()
| Down-cast to OGRPolyhedralSurface*.
const OGRPolyhedralSurface * | toPolyhedralSurface () const
| Down-cast to OGRPolyhedralSurface*.
OGRTriangulatedSurface * | toTriangulatedSurface ()
| Down-cast to OGRTriangulatedSurface*.
const OGRTriangulatedSurface * | toTriangulatedSurface () const
| Down-cast to OGRTriangulatedSurface*.

## Static Public Member Functions
static OGRMultiSurface * | CastToMultiSurface (OGRMultiPolygon *poMP)
| Cast to multisurface.
static OGRMultiPolygon * | CastToMultiPolygon (OGRMultiSurface *poMS)
| Cast to multipolygon.
static OGRGeometryCollection * | CastToGeometryCollection (OGRGeometryCollection *poSrc)
| Cast to geometry collection.
static GEOSContextHandle_t | createGEOSContext ()
| Create a new GEOS context.
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
| Destroy a GEOS context.
static OGRGeometryH | ToHandle (OGRGeometry *poGeom)
| Convert a OGRGeometry* to a OGRGeometryH.
static OGRGeometry * | FromHandle (OGRGeometryH hGeom)
| Convert a OGRGeometryH to a OGRGeometry*.

## Protected Member Functions
OGRBoolean | isCompatibleSubType (OGRwkbGeometryType) const override
| Returns whether a geometry of the specified geometry type can be a member of this collection.

## Friends
class | OGRPolyhedralSurface
class | OGRTriangulatedSurface

## Detailed Description

A collection of non-overlapping OGRPolygon.

## Member Function Documentation

## ◆ accept() [1/2]

void OGRMultiPolygon::accept | ( | IOGRConstGeometryVisitor * | visitor | ) | const
| inline override virtual

Accept a visitor.

Reimplemented from OGRGeometryCollection.

## ◆ accept() [2/2]

void OGRMultiPolygon::accept | ( | IOGRGeometryVisitor * | visitor | ) |
| inline override virtual

Accept a visitor.

Reimplemented from OGRGeometryCollection.

## ◆ addGeometry() [1/2]

OGRErr OGRGeometryCollection::addGeometry | ( | const OGRGeometry * | poNewGeom | ) |
| virtual inherited

Add a geometry to the container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. The passed geometry is cloned to make an internal copy.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_AddGeometry().

Parameters

  poNewGeom | geometry to add to the container.

Returns
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

## ◆ addGeometry() [2/2]

OGRErr OGRGeometryCollection::addGeometry | ( | std::unique_ptr< OGRGeometry > | geom | ) |
| inherited

Add a geometry directly to the container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error.

There is no SFCOM analog to this method.

Parameters

  geom | geometry to add to the container.

Returns
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

## ◆ addGeometryDirectly()

OGRErr OGRGeometryCollection::addGeometryDirectly | ( | OGRGeometry * | poNewGeom | ) |
| virtual inherited

Add a geometry directly to the container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. Ownership of the passed geometry is taken by the container rather than cloning as addGeometry() does, but only if the method is successful. If the method fails, ownership still belongs to the caller.

This method is the same as the C function OGR_G_AddGeometryDirectly().

There is no SFCOM analog to this method.

Parameters

  poNewGeom | geometry to add to the container.

Returns
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

## ◆ assignSpatialReference()

void OGRGeometryCollection::assignSpatialReference | ( | const OGRSpatialReference * | poSR | ) |
| override virtual inherited

Assign spatial reference to this object.

Any existing spatial reference is replaced, but under no circumstances does this result in the object being reprojected. It is just changing the interpretation of the existing geometry. Note that assigning a spatial reference increments the reference count on the OGRSpatialReference, but does not copy it.

This will also assign the spatial reference to potential sub-geometries of the geometry (OGRGeometryCollection, OGRCurvePolygon/OGRPolygon, OGRCompoundCurve, OGRPolyhedralSurface and their derived classes).

This is similar to the SFCOM IGeometry::put_SpatialReference() method.

This method is the same as the C function OGR_G_AssignSpatialReference().

Parameters

  poSR | new spatial reference system to apply.

Reimplemented from OGRGeometry.

## ◆ Boundary()

OGRGeometry * OGRGeometry::Boundary | ( |  | ) | const
| virtual inherited

Compute boundary.

A new geometry object is created and returned containing the boundary of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_Boundary().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ Buffer()

OGRGeometry * OGRGeometry::Buffer | ( | double | dfDist,
|  | int | nQuadSegs = `30`
| ) |  | const
| virtual inherited

Compute buffer of geometry.

Builds a new geometry containing the buffer region around the geometry on which it is invoked. The buffer is a polygon containing the region within the buffer distance of the original geometry.

Some buffer sections are properly described as curves, but are converted to approximate polygons. The nQuadSegs parameter can be used to control how many segments should be used to define a 90 degree curve - a quadrant of a circle. A value of 30 is a reasonable default. Large values result in large numbers of vertices in the resulting buffer geometry while small numbers reduce the accuracy of the result.

This method is the same as the C function OGR_G_Buffer().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfDist | the buffer distance to be applied. Should be expressed into the same unit as the coordinates of the geometry.
  nQuadSegs | the number of segments used to approximate a 90 degree (quadrant) of curvature.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ BufferEx()

OGRGeometry * OGRGeometry::BufferEx | ( | double | dfDist,
|  | CSLConstList | papszOptions
| ) |  | const
| virtual inherited

Compute buffer of geometry.

Builds a new geometry containing the buffer region around the geometry on which it is invoked. The buffer is a polygon containing the region within the buffer distance of the original geometry.

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

The following options are supported. See the GEOS library for more detailed descriptions.

- ENDCAP_STYLE=ROUND/FLAT/SQUARE
- JOIN_STYLE=ROUND/MITRE/BEVEL
- MITRE_LIMIT=double
- QUADRANT_SEGMENTS=int
- SINGLE_SIDED=YES/NO

This function is the same as the C function OGR_G_BufferEx().

Parameters

  dfDist | the buffer distance to be applied. Should be expressed into the same unit as the coordinates of the geometry.
  papszOptions | NULL terminated list of options (may be NULL)

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.10

## ◆ BuildArea()

OGRGeometry * OGRGeometry::BuildArea | ( |  | ) | const
| virtual inherited

Polygonize a linework assuming inner polygons are holes.

This method is the same as the C function OGR_G_BuildArea().

Polygonization is performed similarly to OGRGeometry::Polygonize(). Additionally, holes are dropped and the result is unified producing a single Polygon or a MultiPolygon.

A new geometry object is created and returned: NULL on failure, empty GeometryCollection if the input geometry cannot be polygonized, Polygon or MultiPolygon on success.

This method is built on the GEOSBuildArea_r() function of the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a newly allocated geometry now owned by the caller, or NULL on failure.

Since
  OGR 3.11

## ◆ CastToGeometryCollection()

OGRGeometryCollection * OGRGeometryCollection::CastToGeometryCollection | ( | OGRGeometryCollection * | poSrc | ) |
| static inherited

Cast to geometry collection.

This methods cast a derived class of geometry collection to a plain geometry collection.

The passed in geometry is consumed and a new one returned (or NULL in case of failure).

Parameters

  poSrc | the input geometry - ownership is passed to the method.

Returns
  new geometry.

## ◆ CastToMultiPolygon()

OGRMultiPolygon * OGRMultiSurface::CastToMultiPolygon | ( | OGRMultiSurface * | poMS | ) |
| static inherited

Cast to multipolygon.

This method should only be called if the multisurface actually only contains instances of OGRPolygon. This can be verified if hasCurveGeometry(TRUE) returns FALSE. It is not intended to approximate curve polygons. For that use getLinearGeometry().

The passed in geometry is consumed and a new one returned (or NULL in case of failure).

Parameters

  poMS | the input geometry - ownership is passed to the method.

Returns
  new geometry.

## ◆ CastToMultiSurface()

OGRMultiSurface * OGRMultiPolygon::CastToMultiSurface | ( | OGRMultiPolygon * | poMP | ) |
| static

Cast to multisurface.

The passed in geometry is consumed and a new one returned .

Parameters

  poMP | the input geometry - ownership is passed to the method.

Returns
  new geometry.

## ◆ Centroid()

OGRErr OGRGeometry::Centroid | ( | OGRPoint * | poPoint | ) | const
| virtual inherited

Compute the geometry centroid.

The centroid location is applied to the passed in OGRPoint object. The centroid is not necessarily within the geometry.

This method relates to the SFCOM ISurface::get_Centroid() method however the current implementation based on GEOS can operate on other geometry types such as multipoint, linestring, geometrycollection such as multipolygons. OGC SF SQL 1.1 defines the operation for surfaces (polygons). SQL/MM-Part 3 defines the operation for surfaces and multisurfaces (multipolygons).

This function is the same as the C function OGR_G_Centroid().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Returns
  OGRERR_NONE on success or OGRERR_FAILURE on error.

to OGRPolygon)

## ◆ clone()

OGRMultiPolygon * OGRMultiPolygon::clone | ( |  | ) | const
| override virtual

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns
  a new object instance with the same geometry, and spatial reference system as the original.

Reimplemented from OGRGeometryCollection.

## ◆ closeRings()

void OGRGeometryCollection::closeRings | ( |  | ) |
| override virtual inherited

Force rings to be closed.

If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end.

Reimplemented from OGRGeometry.

## ◆ ConcaveHull()

OGRGeometry * OGRGeometry::ConcaveHull | ( | double | dfRatio,
|  | bool | bAllowHoles
| ) |  | const
| virtual inherited

Compute "concave hull" of a geometry.

The concave hull is fully contained within the convex hull and also contains all the points of the input, but in a smaller area. The area ratio is the ratio of the area of the convex hull and the concave hull. Frequently used to convert a multi-point into a polygonal area. that contains all the points in the input Geometry.

A new geometry object is created and returned containing the concave hull of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_ConcaveHull().

This method is built on the GEOS >= 3.11 library If OGR is built without the GEOS >= 3.11 library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfRatio | Ratio of the area of the convex hull and the concave hull.
  bAllowHoles | Whether holes are allowed.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.6

## ◆ ConstrainedDelaunayTriangulation()

OGRGeometry * OGRGeometry::ConstrainedDelaunayTriangulation | ( |  | ) | const
| virtual inherited

Return a constrained Delaunay triangulation of the vertices of the given polygon(s).

For non-polygonal inputs, silently returns an empty geometry collection.

This function is the same as the C function OGR_G_ConstrainedDelaunayTriangulation().

This function is built on the GEOS library, v3.10 or above. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  OGR 3.12

## ◆ Contains()

OGRBoolean OGRGeometry::Contains | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for containment.

Tests if actual geometry object contains the passed geometry.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Contains().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if poOtherGeom contains this geometry, otherwise FALSE.

Reimplemented in OGRCurvePolygon.

## ◆ ConvexHull()

OGRGeometry * OGRGeometry::ConvexHull | ( |  | ) | const
| virtual inherited

Compute convex hull.

A new geometry object is created and returned containing the convex hull of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_ConvexHull().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ CoordinateDimension()

int OGRGeometry::CoordinateDimension | ( |  | ) | const
| inherited

Get the dimension of the coordinates in this object.

This method is the same as the C function OGR_G_CoordinateDimension().

Returns
  this will return 2 for XY, 3 for XYZ and XYM, and 4 for XYZM data.

## ◆ createGEOSContext()

GEOSContextHandle_t OGRGeometry::createGEOSContext | ( |  | ) |
| static inherited

Create a new GEOS context.

Returns
  a new GEOS context (to be freed with freeGEOSContext())

## ◆ Crosses()

OGRBoolean OGRGeometry::Crosses | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for crossing.

Tests if this geometry and the other passed into the method are crossing.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Crosses().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are crossing, otherwise FALSE.

## ◆ DelaunayTriangulation()

OGRGeometry * OGRGeometry::DelaunayTriangulation | ( | double | dfTolerance,
|  | int | bOnlyEdges
| ) |  | const
| virtual inherited

Return a Delaunay triangulation of the vertices of the geometry.

This function is the same as the C function OGR_G_DelaunayTriangulation().

This function is built on the GEOS library, v3.4 or above. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfTolerance | optional snapping tolerance to use for improved robustness
  bOnlyEdges | if TRUE, will return a MULTILINESTRING, otherwise it will return a GEOMETRYCOLLECTION containing triangular POLYGONs.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ Difference()

OGRGeometry * OGRGeometry::Difference | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute difference.

Generates a new geometry which is the region of this geometry with the region of the second geometry removed.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Difference().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry removed from "this" geometry.

Returns
  a new geometry to be freed by the caller, or NULL if the difference is empty or if an error occurs.

## ◆ Disjoint()

OGRBoolean OGRGeometry::Disjoint | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for disjointness.

Tests if this geometry and the other passed into the method are disjoint.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Disjoint().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are disjoint, otherwise FALSE.

## ◆ Distance()

double OGRGeometry::Distance | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute distance between two geometries.

Returns the shortest distance between the two geometries. The distance is expressed into the same unit as the coordinates of the geometries.

This method is the same as the C function OGR_G_Distance().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry to compare against.

Returns
  the distance between the geometries or -1 if an error occurs.

## ◆ Distance3D()

double OGRGeometry::Distance3D | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Returns the 3D distance between two geometries.

The distance is expressed into the same unit as the coordinates of the geometries.

This method is built on the SFCGAL library, check it for the definition of the geometry operation. If OGR is built without the SFCGAL library, this method will always return -1.0

This function is the same as the C function OGR_G_Distance3D().

Returns
  distance between the two geometries

## ◆ dumpReadable() [1/2]

std::string OGRGeometry::dumpReadable | ( | const char * | pszPrefix = `nullptr`,
|  | CSLConstList | papszOptions = `nullptr`
| ) |  | const
| inherited

Dump geometry in well known text format to indicated output file.

A few options can be defined to change the default dump :

- DISPLAY_GEOMETRY=NO : to hide the dump of the geometry
- DISPLAY_GEOMETRY=WKT or YES (default) : dump the geometry as a WKT
- DISPLAY_GEOMETRY=SUMMARY : to get only a summary of the geometry
- XY_COORD_PRECISION=integer: number of decimal figures for X,Y coordinates in WKT (added in GDAL 3.9)
- Z_COORD_PRECISION=integer: number of decimal figures for Z coordinates in WKT (added in GDAL 3.9)

Parameters

  pszPrefix | the prefix to put on each line of output.
  papszOptions | NULL terminated list of options (may be NULL)

Returns
  a string with the geometry representation.

Since
  GDAL 3.7

## ◆ dumpReadable() [2/2]

void OGRGeometry::dumpReadable | ( | FILE * | fp,
|  | const char * | pszPrefix = `nullptr`,
|  | CSLConstList | papszOptions = `nullptr`
| ) |  | const
| inherited

Dump geometry in well known text format to indicated output file.

A few options can be defined to change the default dump :

- DISPLAY_GEOMETRY=NO : to hide the dump of the geometry
- DISPLAY_GEOMETRY=WKT or YES (default) : dump the geometry as a WKT
- DISPLAY_GEOMETRY=SUMMARY : to get only a summary of the geometry

This method is the same as the C function OGR_G_DumpReadable().

Parameters

  fp | the text file to write the geometry to.
  pszPrefix | the prefix to put on each line of output.
  papszOptions | NULL terminated list of options (may be NULL)

## ◆ empty()

void OGRGeometryCollection::empty | ( |  | ) |
| override virtual inherited

Clear geometry information.

This restores the geometry to its initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

## ◆ Equals()

OGRBoolean OGRGeometryCollection::Equals | ( | const OGRGeometry * |  | ) | const
| override virtual inherited

Returns TRUE if two geometries are equivalent.

This operation implements the SQL/MM ST_OrderingEquals() operation.

The comparison is done in a structural way, that is to say that the geometry types must be identical, as well as the number and ordering of sub-geometries and vertices. Or equivalently, two geometries are considered equal by this method if their WKT/WKB representation is equal. Note: this must be distinguished for equality in a spatial way (which is the purpose of the ST_Equals() operation).

This method is the same as the C function OGR_G_Equals().

Returns
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

## ◆ exportToGEOS()

GEOSGeom OGRGeometry::exportToGEOS | ( | GEOSContextHandle_t | hGEOSCtxt,
|  | bool | bRemoveEmptyParts = `false`
| ) |  | const
| inherited

Returns a GEOSGeom object corresponding to the geometry.

Parameters

  hGEOSCtxt | GEOS context
  bRemoveEmptyParts | Whether empty parts of the geometry should be removed before exporting to GEOS (GDAL >= 3.10)

Returns
  a GEOSGeom object corresponding to the geometry (to be freed with GEOSGeom_destroy_r()), or NULL in case of error

## ◆ exportToGML()

char * OGRGeometry::exportToGML | ( | const char *const * | papszOptions = `nullptr` | ) | const
| virtual inherited

Convert a geometry into GML format.

The GML geometry is expressed directly in terms of GML basic data types assuming the this is available in the gml namespace. The returned string should be freed with CPLFree() when no longer required.

The supported options are :

- FORMAT=GML2/GML3/GML32. If not set, it will default to GML 2.1.2 output.
- GML3_LINESTRING_ELEMENT=curve. (Only valid for FORMAT=GML3) To use gml:Curve element for linestrings. Otherwise gml:LineString will be used .
- GML3_LONGSRS=YES/NO. (Only valid for FORMAT=GML3, deprecated by SRSNAME_FORMAT in GDAL >=2.2). Defaults to YES. If YES, SRS with EPSG authority will be written with the "urn:ogc:def:crs:EPSG::" prefix. In the case the SRS should be treated as lat/long or northing/easting, then the function will take care of coordinate order swapping if the data axis to CRS axis mapping indicates it. If set to NO, SRS with EPSG authority will be written with the "EPSG:" prefix, even if they are in lat/long order.
- SRSNAME_FORMAT=SHORT/OGC_URN/OGC_URL (Only valid for FORMAT=GML3). Defaults to OGC_URN. If SHORT, then srsName will be in the form AUTHORITY_NAME:AUTHORITY_CODE. If OGC_URN, then srsName will be in the form urn:ogc:def:crs:AUTHORITY_NAME::AUTHORITY_CODE. If OGC_URL, then srsName will be in the form http://www.opengis.net/def/crs/AUTHORITY_NAME/0/AUTHORITY_CODE. For OGC_URN and OGC_URL, in the case the SRS should be treated as lat/long or northing/easting, then the function will take care of coordinate order swapping if the data axis to CRS axis mapping indicates it.
- GMLID=astring. If specified, a gml:id attribute will be written in the top-level geometry element with the provided value. Required for GML 3.2 compatibility.
- SRSDIMENSION_LOC=POSLIST/GEOMETRY/GEOMETRY,POSLIST. (Only valid for FORMAT=GML3/GML32) Default to POSLIST. For 2.5D geometries, define the location where to attach the srsDimension attribute. There are diverging implementations. Some put in on the <gml:posList> element, other on the top geometry element.
- NAMESPACE_DECL=YES/NO. If set to YES, xmlns:gml="http://www.opengis.net/gml" will be added to the root node for GML < 3.2 or xmlns:gml="http://www.opengis.net/gml/3.2" for GML 3.2
- XY_COORD_RESOLUTION=double (added in GDAL 3.9): Resolution for the coordinate precision of the X and Y coordinates. Expressed in the units of the X and Y axis of the SRS. eg 1e-5 for up to 5 decimal digits. 0 for the default behavior.
- Z_COORD_RESOLUTION=double (added in GDAL 3.9): Resolution for the coordinate precision of the Z coordinates. Expressed in the units of the Z axis of the SRS. 0 for the default behavior.

This method is the same as the C function OGR_G_ExportToGMLEx().

Parameters

  papszOptions | NULL-terminated list of options.

Returns
  A GML fragment to be freed with CPLFree() or NULL in case of error.

## ◆ exportToJson()

char * OGRGeometry::exportToJson | ( | CSLConstList | papszOptions = `nullptr` | ) | const
| virtual inherited

Convert a geometry into GeoJSON format.

The returned string should be freed with CPLFree() when no longer required.

The following options are supported :

- XY_COORD_PRECISION=integer: number of decimal figures for X,Y coordinates (added in GDAL 3.9)
- Z_COORD_PRECISION=integer: number of decimal figures for Z coordinates (added in GDAL 3.9)

This method is the same as the C function OGR_G_ExportToJson().

Parameters

  papszOptions | Null terminated list of options, or null (added in 3.9)

Returns
  A GeoJSON fragment to be freed with CPLFree() or NULL in case of error.

## ◆ exportToKML()

char * OGRGeometry::exportToKML | ( |  | ) | const
| virtual inherited

Convert a geometry into KML format.

The returned string should be freed with CPLFree() when no longer required.

This method is the same as the C function OGR_G_ExportToKML().

Returns
  A KML fragment to be freed with CPLFree() or NULL in case of error.

## ◆ exportToWkb() [1/2]

OGRErr OGRGeometry::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| inherited

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters

  eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns
  Currently OGRERR_NONE is always returned.

## ◆ exportToWkb() [2/2]

OGRErr OGRGeometryCollection::exportToWkb | ( | unsigned char * | pabyDstBuffer,
|  | const OGRwkbExportOptions * | psOptions = `nullptr`
| ) |  | const
| override virtual inherited

Convert a geometry into well known binary format.

This function relates to the SFCOM IWks::ExportToWKB() method.

This function is the same as the C function OGR_G_ExportToWkbEx().

Parameters

  pabyDstBuffer | a buffer into which the binary representation is written. This buffer must be at least OGR_G_WkbSize() byte in size.
  psOptions | WKB export options.

Returns
  Currently OGRERR_NONE is always returned.

Since
  GDAL 3.9

Implements OGRGeometry.

## ◆ exportToWkt() [1/3]

OGRErr OGRGeometry::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | variant = `wkbVariantOldOgc`
| ) |  | const

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters

  ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with CPLFree().
  variant | the specification that must be conformed too : wkbVariantOgc for old-style 99-402 extended dimension (Z) WKB types wkbVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns
  Currently OGRERR_NONE is always returned.

## ◆ exportToWkt() [2/3]

std::string OGRMultiPolygon::exportToWkt | ( | const OGRWktOptions & | opts = `OGRWktOptions()`,
|  | OGRErr * | err = `nullptr`
| ) |  | const
| override virtual

Export a multipolygon to WKT.

Parameters

  opts | Output options.
  err | Pointer to error code, if desired.

Returns
  WKT representation of the multipolygon.

Reimplemented from OGRMultiSurface.

## ◆ exportToWkt() [3/3]

virtual std::string OGRGeometry::exportToWkt | ( | const OGRWktOptions & | opts = `OGRWktOptions()`,
|  | OGRErr * | err = `nullptr`
| ) |  | const
| virtual

Export a WKT geometry.

Parameters

  opts | Output options.
  err | Pointer to error code, if desired.

Returns
  WKT string representing this geometry.

Reimplemented from OGRMultiSurface.

## ◆ flattenTo2D()

void OGRGeometryCollection::flattenTo2D | ( |  | ) |
| override virtual inherited

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

## ◆ freeGEOSContext()

void OGRGeometry::freeGEOSContext | ( | GEOSContextHandle_t | hGEOSCtxt | ) |
| static inherited

Destroy a GEOS context.

Parameters

  hGEOSCtxt | GEOS context

## ◆ get_Area()

double OGRGeometryCollection::get_Area | ( |  | ) | const
| virtual inherited

Compute area of geometry collection.

The area is computed as the sum of the areas of all members in this collection.

Note
  No warning will be issued if a member of the collection does not support the get_Area method.

Returns
  computed area.

## ◆ get_GeodesicArea()

double OGRGeometryCollection::get_GeodesicArea | ( | const OGRSpatialReference * | poSRSOverride = `nullptr` | ) | const
| virtual inherited

Compute area of geometry collection, considered as a surface on the underlying ellipsoid of the SRS attached to the geometry.

The returned area will always be in square meters, and assumes that polygon edges describe geodesic lines on the ellipsoid.

Geodesics follow the shortest route on the surface of the ellipsoid.

If the geometry' SRS is not a geographic one, geometries are reprojected to the underlying geographic SRS of the geometry' SRS. OGRSpatialReference::GetDataAxisToSRSAxisMapping() is honored.

The area is computed as the sum of the areas of all members in this collection.

Note
  No warning will be issued if a member of the collection does not support the get_GeodesicArea method.

Parameters

  poSRSOverride | If not null, overrides OGRGeometry::getSpatialReference()

Returns
  the area of the geometry in square meters, or a negative value in case of error.

See also
  get_Area() for an alternative method returning areas computed in 2D Cartesian space.

Since
  GDAL 3.9

## ◆ get_GeodesicLength()

double OGRGeometryCollection::get_GeodesicLength | ( | const OGRSpatialReference * | poSRSOverride = `nullptr` | ) | const
| virtual inherited

Get the length of the collection,where curve edges are geodesic lines on the underlying ellipsoid of the SRS attached to the geometry.

The returned length will always be in meters.

Geodesics follow the shortest route on the surface of the ellipsoid.

If the geometry' SRS is not a geographic one, geometries are reprojected to the underlying geographic SRS of the geometry' SRS. OGRSpatialReference::GetDataAxisToSRSAxisMapping() is honored.

Note that geometries with circular arcs will be linearized in their original coordinate space first, so the resulting geodesic length will be an approximation.

The length is computed as the sum of the lengths of all members in this collection.

Note
  No warning will be issued if a member of the collection does not support the get_GeodesicLength method.

Parameters

  poSRSOverride | If not null, overrides OGRGeometry::getSpatialReference()

Returns
  the length of the geometry in meters, or a negative value in case of error.

See also
  get_Length() for an alternative method returning areas computed in 2D Cartesian space.

Since
  GDAL 3.10

## ◆ get_Length()

double OGRGeometryCollection::get_Length | ( |  | ) | const
| virtual inherited

Compute the length of a multicurve.

The length is computed as the sum of the length of all members in this collection.

Note
  No warning will be issued if a member of the collection does not support the get_Length method.

Returns
  computed length.

## ◆ getCoordinateDimension()

int OGRGeometry::getCoordinateDimension | ( |  | ) | const
| virtual inherited

Get the dimension of the coordinates in this object.

This method is the same as the C function OGR_G_GetCoordinateDimension().

Deprecated:
  use CoordinateDimension().

Returns
  this will return 2 or 3.

## ◆ getCurveGeometry()

OGRGeometry * OGRGeometryCollection::getCurveGeometry | ( | const char *const * | papszOptions = `nullptr` | ) | const
| override virtual inherited

Return curve version of this geometry.

Returns a geometry that has possibly CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by de-approximating curve geometries.

If the geometry has no curve portion, the returned geometry will be a clone of it.

The ownership of the returned geometry belongs to the caller.

The reverse method is OGRGeometry::getLinearGeometry().

This function is the same as C function OGR_G_GetCurveGeometry().

Parameters

  papszOptions | options as a null-terminated list of strings. Unused for now. Must be set to NULL.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Reimplemented from OGRGeometry.

## ◆ getDimension()

int OGRMultiSurface::getDimension | ( |  | ) | const
| override virtual inherited

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns
  0 for points, 1 for lines and 2 for surfaces.

Reimplemented from OGRGeometryCollection.

## ◆ getEnvelope() [1/2]

void OGRGeometryCollection::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const
| override virtual inherited

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters

  psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

## ◆ getEnvelope() [2/2]

void OGRGeometryCollection::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const
| override virtual inherited

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters

  psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

## ◆ getGeometryName()

const char * OGRMultiPolygon::getGeometryName | ( |  | ) | const
| override virtual

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Reimplemented from OGRGeometryCollection.

## ◆ getGeometryType()

OGRwkbGeometryType OGRMultiPolygon::getGeometryType | ( |  | ) | const
| override virtual

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns
  the geometry type code.

Reimplemented from OGRGeometryCollection.

## ◆ getIsoGeometryType()

OGRwkbGeometryType OGRGeometry::getIsoGeometryType | ( |  | ) | const
| inherited

Get the geometry type that conforms with ISO SQL/MM Part3.

Returns
  the geometry type that conforms with ISO SQL/MM Part3

## ◆ getLinearGeometry()

OGRGeometry * OGRGeometryCollection::getLinearGeometry | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `nullptr`
| ) |  | const
| override virtual inherited

Return, possibly approximate, non-curve version of this geometry.

Returns a geometry that has no CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by approximating curve geometries.

The ownership of the returned geometry belongs to the caller.

The reverse method is OGRGeometry::getCurveGeometry().

This method is the same as the C function OGR_G_GetLinearGeometry().

Parameters

  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  papszOptions | options as a null-terminated list of strings. See OGRGeometryFactory::curveToLineString() for valid options.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Reimplemented from OGRGeometry.

## ◆ getNumGeometries()

int OGRGeometryCollection::getNumGeometries | ( |  | ) | const
| inherited

Fetch number of geometries in container.

This method relates to the SFCOM IGeometryCollect::get_NumGeometries() method.

Returns
  count of children geometries. May be zero.

## ◆ getSpatialReference()

OGRSpatialReference * OGRGeometry::getSpatialReference | ( | void |  | ) | const
| inline inherited

Returns spatial reference system for object.

This method relates to the SFCOM IGeometry::get_SpatialReference() method.

This method is the same as the C function OGR_G_GetSpatialReference().

Returns
  a reference to the spatial reference object. The object may be shared with many geometry objects, and should not be modified.

## ◆ hasCurveGeometry()

OGRBoolean OGRMultiPolygon::hasCurveGeometry | ( | int | bLookForNonLinear = `FALSE` | ) | const
| override virtual

Returns if this geometry is or has curve geometry.

Returns if a geometry is, contains or may contain a CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE.

If bLookForNonLinear is set to TRUE, it will be actually looked if the geometry or its subgeometries are or contain a non-linear geometry in them. In which case, if the method returns TRUE, it means that getLinearGeometry() would return an approximate version of the geometry. Otherwise, getLinearGeometry() would do a conversion, but with just converting container type, like COMPOUNDCURVE -> LINESTRING, MULTICURVE -> MULTILINESTRING or MULTISURFACE -> MULTIPOLYGON, resulting in a "loss-less" conversion.

This method is the same as the C function OGR_G_HasCurveGeometry().

Parameters

  bLookForNonLinear | set it to TRUE to check if the geometry is or contains a CIRCULARSTRING.

Returns
  TRUE if this geometry is or has curve geometry.

Reimplemented from OGRMultiSurface.

## ◆ hasEmptyParts()

bool OGRGeometryCollection::hasEmptyParts | ( |  | ) | const
| override virtual inherited

Returns whether a geometry has empty parts/rings.

Returns true if removeEmptyParts() will modify the geometry.

This is different from IsEmpty().

Since
  GDAL 3.10

Reimplemented from OGRGeometry.

## ◆ importFromWkb() [1/2]

OGRErr OGRGeometry::importFromWkb | ( | const GByte * | pabyData,
|  | size_t | nSize = `static_cast<size_t>(-1)`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  |
| inherited

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or -1 if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

## ◆ importFromWkb() [2/2]

OGRErr OGRMultiPolygon::importFromWkb | ( | const unsigned char * | pabyData,
|  | size_t | nSize,
|  | OGRwkbVariant | eWkbVariant,
|  | size_t & | nBytesConsumedOut
| ) |  |
| override virtual

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or -1 if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code
  nBytesConsumedOut | output parameter. Number of bytes consumed.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Reimplemented from OGRGeometryCollection.

## ◆ importFromWkt() [1/3]

OGRErr OGRGeometry::importFromWkt | ( | char ** | ppszInput | ) |
| inline inherited

Deprecated.

Deprecated:

## ◆ importFromWkt() [2/3]

OGRErr OGRMultiSurface::importFromWkt | ( | const char ** | ppszInput | ) |
| override virtual inherited

deprecated

Reimplemented from OGRGeometryCollection.

## ◆ importFromWkt() [3/3]

OGRErr OGRGeometry::importFromWkt | ( | const char ** | ppszInput | ) |
| virtual inherited

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters

  ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Reimplemented from OGRGeometryCollection.

## ◆ Intersection()

OGRGeometry * OGRGeometry::Intersection | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute intersection.

Generates a new geometry which is the region of intersection of the two geometries operated on. The Intersects() method can be used to test if two geometries intersect.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Intersection().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry intersected with "this" geometry.

Returns
  a new geometry to be freed by the caller, or NULL if there is no intersection or if an error occurs.

## ◆ Intersects()

OGRBoolean OGRGeometry::Intersects | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Do these features intersect?

Determines whether two geometries intersect. If GEOS is enabled, then this is done in rigorous fashion otherwise TRUE is returned if the envelopes (bounding boxes) of the two geometries overlap.

The poOtherGeom argument may be safely NULL, but in this case the method will always return TRUE. That is, a NULL geometry is treated as being everywhere.

This method is the same as the C function OGR_G_Intersects().

Parameters

  poOtherGeom | the other geometry to test against.

Returns
  TRUE if the geometries intersect, otherwise FALSE.

Reimplemented in OGRPoint, and OGRCurvePolygon.

## ◆ Is3D()

OGRBoolean OGRGeometry::Is3D | ( |  | ) | const
| inline inherited

Returns whether the geometry has a Z component.

## ◆ isCompatibleSubType()

OGRBoolean OGRMultiPolygon::isCompatibleSubType | ( | OGRwkbGeometryType | eSubType | ) | const
| override protected virtual

Returns whether a geometry of the specified geometry type can be a member of this collection.

Parameters

  eSubType | type of the potential member

Returns
  TRUE or FALSE

Reimplemented from OGRGeometryCollection.

## ◆ IsEmpty()

OGRBoolean OGRGeometryCollection::IsEmpty | ( |  | ) | const
| override virtual inherited

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns
  TRUE if object is empty, otherwise FALSE.

Implements OGRGeometry.

## ◆ IsMeasured()

OGRBoolean OGRGeometry::IsMeasured | ( |  | ) | const
| inline inherited

Returns whether the geometry has a M component.

## ◆ IsRectangle()

bool OGRGeometry::IsRectangle | ( |  | ) | const
| inherited

Returns whether the geometry is a polygon with 4 corners forming a rectangle.

Since
  GDAL 3.10

## ◆ IsRing()

OGRBoolean OGRGeometry::IsRing | ( |  | ) | const
| virtual inherited

Test if the geometry is a ring.

This method is the same as the C function OGR_G_IsRing().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns
  TRUE if the coordinates of the geometry form a ring, by checking length and closure (self-intersection is not checked), otherwise FALSE.

## ◆ IsSimple()

OGRBoolean OGRGeometry::IsSimple | ( |  | ) | const
| virtual inherited

Test if the geometry is simple.

This method is the same as the C function OGR_G_IsSimple().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

## ◆ IsValid()

OGRBoolean OGRGeometry::IsValid | ( |  | ) | const
| virtual inherited

Test if the geometry is valid.

This method is the same as the C function OGR_G_IsValid().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

Reimplemented in OGRCircularString.

## ◆ MakeValid()

OGRGeometry * OGRGeometry::MakeValid | ( | CSLConstList | papszOptions = `nullptr` | ) | const
| virtual inherited

Attempts to make an invalid geometry valid without losing vertices.

Already-valid geometries are cloned without further intervention for default MODE=LINEWORK. Already-valid geometries with MODE=STRUCTURE may be subject to non-significant transformations, such as duplicated point removal, change in ring winding order, etc. (before GDAL 3.10, single-part geometry collections could be returned a single geometry. GDAL 3.10 returns the same type of geometry).

Running OGRGeometryFactory::removeLowerDimensionSubGeoms() as a post-processing step is often desired.

This method is the same as the C function OGR_G_MakeValid().

This function is built on the GEOS >= 3.8 library, check it for the definition of the geometry operation. If OGR is built without the GEOS >= 3.8 library, this function will return a clone of the input geometry if it is valid, or NULL if it is invalid

Parameters

  papszOptions | NULL terminated list of options, or NULL. The following options are available: METHOD=LINEWORK/STRUCTURE. LINEWORK is the default method, which combines all rings into a set of noded lines and then extracts valid polygons from that linework. The STRUCTURE method (requires GEOS >= 3.10 and GDAL >= 3.4) first makes all rings valid, then merges shells and subtracts holes from shells to generate valid result. Assumes that holes and shells are correctly categorized. KEEP_COLLAPSED=YES/NO. Only for METHOD=STRUCTURE. NO (default): collapses are converted to empty geometries YES: collapses are converted to a valid geometry of lower dimension.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.0

## ◆ Normalize()

OGRGeometry * OGRGeometry::Normalize | ( |  | ) | const
| virtual inherited

Attempts to bring geometry into normalized/canonical form.

This method is the same as the C function OGR_G_Normalize().

This function is built on the GEOS library; check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.3

## ◆ Overlaps()

OGRBoolean OGRGeometry::Overlaps | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for overlap.

Tests if this geometry and the other passed into the method overlap, that is their intersection has a non-zero area.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Overlaps().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are overlapping, otherwise FALSE.

## ◆ PointOnSurface()

OGRErr OGRMultiSurface::PointOnSurface | ( | OGRPoint * | poPoint | ) | const
| virtual inherited

This method relates to the SFCOM IMultiSurface::get_PointOnSurface() method.

NOTE: Only implemented when GEOS included in build.

Parameters

  poPoint | point to be set with an internal point.

Returns
  OGRERR_NONE if it succeeds or OGRERR_FAILURE otherwise.

## ◆ Polygonize()

OGRGeometry * OGRGeometry::Polygonize | ( |  | ) | const
| virtual inherited

Polygonizes a set of sparse edges.

A new geometry object is created and returned containing a collection of reassembled Polygons: NULL will be returned if the input collection doesn't corresponds to a MultiLinestring, or when reassembling Edges into Polygons is impossible due to topological inconsistencies.

This method is the same as the C function OGR_G_Polygonize().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ removeEmptyParts()

void OGRGeometryCollection::removeEmptyParts | ( |  | ) |
| override virtual inherited

Remove empty parts/rings from this geometry.

Since
  GDAL 3.10

Reimplemented from OGRGeometry.

## ◆ removeGeometry()

OGRErr OGRGeometryCollection::removeGeometry | ( | int | iGeom,
|  | int | bDelete = `TRUE`
| ) |  |
| virtual inherited

Remove a geometry from the container.

Removing a geometry will cause the geometry count to drop by one, and all "higher" geometries will shuffle down one in index.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_RemoveGeometry().

Parameters

  iGeom | the index of the geometry to delete. A value of -1 is a special flag meaning that all geometries should be removed.
  bDelete | if TRUE the geometry will be deallocated, otherwise it will not. The default is TRUE as the container is considered to own the geometries in it. Note: using stealGeometry() might be a better alternative to using bDelete = false.

Returns
  OGRERR_NONE if successful, or OGRERR_FAILURE if the index is out of range.

## ◆ roundCoordinates()

void OGRGeometry::roundCoordinates | ( | const OGRGeomCoordinatePrecision & | sPrecision | ) |
| inherited

Round coordinates of the geometry to the specified precision.

Note that this is not the same as OGRGeometry::SetPrecision(). The later will return valid geometries, whereas roundCoordinates() does not make such guarantee and may return geometries with invalidities, if they are not compatible of the specified precision. roundCoordinates() supports curve geometries, whereas SetPrecision() does not currently.

One use case for roundCoordinates() is to undo the effect of quantizeCoordinates().

Parameters

  sPrecision | Contains the precision requirements.

Since
  GDAL 3.9

## ◆ roundCoordinatesIEEE754()

void OGRGeometry::roundCoordinatesIEEE754 | ( | const OGRGeomCoordinateBinaryPrecision & | options | ) |
| inherited

Round coordinates of a geometry, exploiting characteristics of the IEEE-754 double-precision binary representation.

Determines the number of bits (N) required to represent a coordinate value with a specified number of digits after the decimal point, and then sets all but the N most significant bits to zero. The resulting coordinate value will still round to the original value (e.g. after roundCoordinates()), but will have improved compressiblity.

Parameters

  options | Contains the precision requirements.

Since
  GDAL 3.9

## ◆ segmentize()

bool OGRGeometryCollection::segmentize | ( | double | dfMaxLength | ) |
| override virtual inherited

Modify the geometry such it has no segment longer then the given distance.

This method modifies the geometry to add intermediate vertices if necessary so that the maximum length between 2 consecutive vertices is lower than dfMaxLength.

Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the C function OGR_G_Segmentize()

Parameters

  dfMaxLength | the maximum distance between 2 points after segmentization

Returns
  (since 3.10) true in case of success, false in case of error.

Reimplemented from OGRGeometry.

## ◆ set3D()

bool OGRGeometryCollection::set3D | ( | OGRBoolean | bIs3D | ) |
| override virtual inherited

Add or remove the Z coordinate dimension.

This method adds or removes the explicit Z coordinate dimension. Removing the Z coordinate dimension of a geometry will remove any existing Z values. Adding the Z dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIs3D | Should the geometry have a Z dimension, either TRUE or FALSE.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

Reimplemented from OGRGeometry.

## ◆ setCoordinateDimension()

bool OGRGeometryCollection::setCoordinateDimension | ( | int | nNewDimension | ) |
| override virtual inherited

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection, a compound curve, a polygon, etc. will affect the children geometries. This will also remove the M dimension if present before this call.

Deprecated:
  use set3D() or setMeasured().

Parameters

  nNewDimension | New coordinate dimension value, either 2 or 3.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

Reimplemented from OGRGeometry.

## ◆ setMeasured()

bool OGRGeometryCollection::setMeasured | ( | OGRBoolean | bIsMeasured | ) |
| override virtual inherited

Add or remove the M coordinate dimension.

This method adds or removes the explicit M coordinate dimension. Removing the M coordinate dimension of a geometry will remove any existing M values. Adding the M dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIsMeasured | Should the geometry have a M dimension, either TRUE or FALSE.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

Reimplemented from OGRGeometry.

## ◆ SetPrecision()

OGRGeometry * OGRGeometry::SetPrecision | ( | double | dfGridSize,
|  | int | nFlags
| ) |  | const
| inherited

Set the geometry's precision, rounding all its coordinates to the precision grid, and making sure the geometry is still valid.

This is a stronger version of roundCoordinates().

Note that at time of writing GEOS does no supported curve geometries. So currently if this function is called on such a geometry, OGR will first call getLinearGeometry() on the input and getCurveGeometry() on the output, but that it is unlikely to yield to the expected result.

This function is the same as the C function OGR_G_SetPrecision().

This function is built on the GEOSGeom_setPrecision_r() function of the GEOS library. Check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfGridSize | size of the precision grid, or 0 for FLOATING precision.
  nFlags | The bitwise OR of zero, one or several of OGR_GEOS_PREC_NO_TOPO and OGR_GEOS_PREC_KEEP_COLLAPSED

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.9

## ◆ Simplify()

OGRGeometry * OGRGeometry::Simplify | ( | double | dTolerance | ) | const
| virtual inherited

Simplify the geometry.

This function is the same as the C function OGR_G_Simplify().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dTolerance | the distance tolerance for the simplification.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ SimplifyPreserveTopology()

OGRGeometry * OGRGeometry::SimplifyPreserveTopology | ( | double | dTolerance | ) | const
| inherited

Simplify the geometry while preserving topology.

This function is the same as the C function OGR_G_SimplifyPreserveTopology().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dTolerance | the distance tolerance for the simplification.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ stealGeometry()

std::unique_ptr< OGRGeometry > OGRGeometryCollection::stealGeometry | ( | int | iGeom | ) |
| inherited

Remove a geometry from the container and return it to the caller.

Removing a geometry will cause the geometry count to drop by one, and all "higher" geometries will shuffle down one in index.

There is no SFCOM analog to this method.

Parameters

  iGeom | the index of the geometry to delete.

Returns
  the sub-geometry, or nullptr in case of error.

Since
  3.10

## ◆ swapXY()

void OGRGeometryCollection::swapXY | ( |  | ) |
| override virtual inherited

Swap x and y coordinates.

Reimplemented from OGRGeometry.

## ◆ SymDifference()

OGRGeometry * OGRGeometry::SymDifference | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute symmetric difference.

Generates a new geometry which is the symmetric difference of this geometry and the second geometry passed into the method.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_SymDifference().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry.

Returns
  a new geometry to be freed by the caller, or NULL if the difference is empty or if an error occurs.

## ◆ toCircularString() [1/2]

OGRCircularString * OGRGeometry::toCircularString | ( |  | ) |
| inline inherited

Down-cast to OGRCircularString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCircularString.

## ◆ toCircularString() [2/2]

const OGRCircularString * OGRGeometry::toCircularString | ( |  | ) | const
| inline inherited

Down-cast to OGRCircularString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCircularString.

## ◆ toCompoundCurve() [1/2]

OGRCompoundCurve * OGRGeometry::toCompoundCurve | ( |  | ) |
| inline inherited

Down-cast to OGRCompoundCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCompoundCurve.

## ◆ toCompoundCurve() [2/2]

const OGRCompoundCurve * OGRGeometry::toCompoundCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRCompoundCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCompoundCurve.

## ◆ toCurve() [1/2]

OGRCurve * OGRGeometry::toCurve | ( |  | ) |
| inline inherited

Down-cast to OGRCurve*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbCurve).

## ◆ toCurve() [2/2]

const OGRCurve * OGRGeometry::toCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRCurve*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbCurve).

## ◆ toCurvePolygon() [1/2]

OGRCurvePolygon * OGRGeometry::toCurvePolygon | ( |  | ) |
| inline inherited

Down-cast to OGRCurvePolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCurvePolygon or wkbPolygon or wkbTriangle.

## ◆ toCurvePolygon() [2/2]

const OGRCurvePolygon * OGRGeometry::toCurvePolygon | ( |  | ) | const
| inline inherited

Down-cast to OGRCurvePolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCurvePolygon or wkbPolygon or wkbTriangle.

## ◆ toGeometryCollection() [1/2]

OGRGeometryCollection * OGRGeometry::toGeometryCollection | ( |  | ) |
| inline inherited

Down-cast to OGRGeometryCollection*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbGeometryCollection).

## ◆ toGeometryCollection() [2/2]

const OGRGeometryCollection * OGRGeometry::toGeometryCollection | ( |  | ) | const
| inline inherited

Down-cast to OGRGeometryCollection*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbGeometryCollection).

## ◆ toLinearRing() [1/2]

OGRLinearRing * OGRGeometry::toLinearRing | ( |  | ) |
| inline inherited

Down-cast to OGRLinearRing*.

Implies prior checking that EQUAL(getGeometryName(), "LINEARRING").

## ◆ toLinearRing() [2/2]

const OGRLinearRing * OGRGeometry::toLinearRing | ( |  | ) | const
| inline inherited

Down-cast to OGRLinearRing*.

Implies prior checking that EQUAL(getGeometryName(), "LINEARRING").

## ◆ toLineString() [1/2]

OGRLineString * OGRGeometry::toLineString | ( |  | ) |
| inline inherited

Down-cast to OGRLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString.

## ◆ toLineString() [2/2]

const OGRLineString * OGRGeometry::toLineString | ( |  | ) | const
| inline inherited

Down-cast to OGRLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString.

## ◆ toMultiCurve() [1/2]

OGRMultiCurve * OGRGeometry::toMultiCurve | ( |  | ) |
| inline inherited

Down-cast to OGRMultiCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiCurve and derived types.

## ◆ toMultiCurve() [2/2]

const OGRMultiCurve * OGRGeometry::toMultiCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiCurve and derived types.

## ◆ toMultiLineString() [1/2]

OGRMultiLineString * OGRGeometry::toMultiLineString | ( |  | ) |
| inline inherited

Down-cast to OGRMultiLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiLineString.

## ◆ toMultiLineString() [2/2]

const OGRMultiLineString * OGRGeometry::toMultiLineString | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiLineString.

## ◆ toMultiPoint() [1/2]

OGRMultiPoint * OGRGeometry::toMultiPoint | ( |  | ) |
| inline inherited

Down-cast to OGRMultiPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPoint.

## ◆ toMultiPoint() [2/2]

const OGRMultiPoint * OGRGeometry::toMultiPoint | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPoint.

## ◆ toMultiPolygon() [1/2]

OGRMultiPolygon * OGRGeometry::toMultiPolygon | ( |  | ) |
| inline inherited

Down-cast to OGRMultiPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPolygon.

## ◆ toMultiPolygon() [2/2]

const OGRMultiPolygon * OGRGeometry::toMultiPolygon | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPolygon.

## ◆ toMultiSurface() [1/2]

OGRMultiSurface * OGRGeometry::toMultiSurface | ( |  | ) |
| inline inherited

Down-cast to OGRMultiSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiSurface and derived types.

## ◆ toMultiSurface() [2/2]

const OGRMultiSurface * OGRGeometry::toMultiSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiSurface and derived types.

## ◆ toPoint() [1/2]

OGRPoint * OGRGeometry::toPoint | ( |  | ) |
| inline inherited

Down-cast to OGRPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPoint.

## ◆ toPoint() [2/2]

const OGRPoint * OGRGeometry::toPoint | ( |  | ) | const
| inline inherited

Down-cast to OGRPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPoint.

## ◆ toPolygon() [1/2]

OGRPolygon * OGRGeometry::toPolygon | ( |  | ) |
| inline inherited

Down-cast to OGRPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolygon or wkbTriangle.

## ◆ toPolygon() [2/2]

const OGRPolygon * OGRGeometry::toPolygon | ( |  | ) | const
| inline inherited

Down-cast to OGRPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolygon or wkbTriangle.

## ◆ toPolyhedralSurface() [1/2]

OGRPolyhedralSurface * OGRGeometry::toPolyhedralSurface | ( |  | ) |
| inline inherited

Down-cast to OGRPolyhedralSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolyhedralSurface or wkbTIN.

## ◆ toPolyhedralSurface() [2/2]

const OGRPolyhedralSurface * OGRGeometry::toPolyhedralSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRPolyhedralSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolyhedralSurface or wkbTIN.

## ◆ toSimpleCurve() [1/2]

OGRSimpleCurve * OGRGeometry::toSimpleCurve | ( |  | ) |
| inline inherited

Down-cast to OGRSimpleCurve*.

Implies prior checking that getGeometryType() is wkbLineString, wkbCircularString or a derived type.

## ◆ toSimpleCurve() [2/2]

const OGRSimpleCurve * OGRGeometry::toSimpleCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRSimpleCurve*.

Implies prior checking that getGeometryType() is wkbLineString, wkbCircularString or a derived type.

## ◆ toSurface() [1/2]

OGRSurface * OGRGeometry::toSurface | ( |  | ) |
| inline inherited

Down-cast to OGRSurface*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbSurface).

## ◆ toSurface() [2/2]

const OGRSurface * OGRGeometry::toSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRSurface*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbSurface).

## ◆ toTriangle() [1/2]

OGRTriangle * OGRGeometry::toTriangle | ( |  | ) |
| inline inherited

Down-cast to OGRTriangle*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTriangle.

## ◆ toTriangle() [2/2]

const OGRTriangle * OGRGeometry::toTriangle | ( |  | ) | const
| inline inherited

Down-cast to OGRTriangle*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTriangle.

## ◆ toTriangulatedSurface() [1/2]

OGRTriangulatedSurface * OGRGeometry::toTriangulatedSurface | ( |  | ) |
| inline inherited

Down-cast to OGRTriangulatedSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTIN.

## ◆ toTriangulatedSurface() [2/2]

const OGRTriangulatedSurface * OGRGeometry::toTriangulatedSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRTriangulatedSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTIN.

## ◆ Touches()

OGRBoolean OGRGeometry::Touches | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for touching.

Tests if this geometry and the other passed into the method are touching.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Touches().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are touching, otherwise FALSE.

## ◆ transform()

OGRErr OGRGeometryCollection::transform | ( | OGRCoordinateTransformation * | poCT | ) |
| override virtual inherited

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method only does reprojection on a point-by-point basis. It does not include advanced logic to deal with discontinuities at poles or antimeridian. For that, use the OGRGeometryFactory::transformWithOptions() method.

This method is the same as the C function OGR_G_Transform().

Parameters

  poCT | the transformation to apply.

Returns
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

## ◆ transformTo()

OGRErr OGRGeometry::transformTo | ( | const OGRSpatialReference * | poSR | ) |
| inherited

Transform geometry to new spatial reference system.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

This method will only work if the geometry already has an assigned spatial reference system, and if it is transformable to the target coordinate system.

Because this method requires internal creation and initialization of an OGRCoordinateTransformation object it is significantly more expensive to use this method to transform many geometries than it is to create the OGRCoordinateTransformation in advance, and call transform() with that transformation. This method exists primarily for convenience when only transforming a single geometry.

This method is the same as the C function OGR_G_TransformTo().

Parameters

  poSR | spatial reference system to transform to.

Returns
  OGRERR_NONE on success, or an error code.

## ◆ UnaryUnion()

OGRGeometry * OGRGeometry::UnaryUnion | ( |  | ) | const
| inherited

Returns the union of all components of a single geometry.

Usually used to convert a collection into the smallest set of polygons that cover the same area.

See https://postgis.net/docs/ST_UnaryUnion.html for more details.

This method is the same as the C function OGR_G_UnaryUnion().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.7

## ◆ Union()

OGRGeometry * OGRGeometry::Union | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute union.

Generates a new geometry which is the region of union of the two geometries operated on.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Union().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry unioned with "this" geometry.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ UnionCascaded()

OGRGeometry * OGRGeometry::UnionCascaded | ( |  | ) | const
| virtual inherited

Compute union using cascading.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

The input geometry must be a MultiPolygon.

This method is the same as the C function OGR_G_UnionCascaded().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Deprecated:
  Use UnaryUnion() instead

## ◆ Within()

OGRBoolean OGRGeometry::Within | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for containment.

Tests if actual geometry object is within the passed geometry.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Within().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if poOtherGeom is within this geometry, otherwise FALSE.

Reimplemented in OGRPoint.

## ◆ WkbSize()

size_t OGRGeometryCollection::WkbSize | ( |  | ) | const
| override virtual inherited

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns
  size of binary representation in bytes.

Implements OGRGeometry.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrmultipolygon.cpp